package com.eco.plugin.xxx.bjgjdata.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "单点登录配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xxx.bjgjdata.config", text = "单点登录配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "apikey", name = "apikey", description = "apikey", status = Status.SHOW)
    private Conf<String> apikey = Holders.simple("");

    @Identifier(value = "clientId", name = "clientId", description = "clientId", status = Status.SHOW)
    private Conf<String> clientId = Holders.simple("");

    @Identifier(value = "secret", name = "clientSecret", description = "clientSecret", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("");

    @Identifier(value = "tokenurl", name = "获取token接口", description = "获取token接口", status = Status.SHOW)
    private Conf<String> tokenurl = Holders.simple("http://localhost:8075/webroot/decision");

    @Identifier(value = "dataurl", name = "获取数据接口", description = "获取数据接口", status = Status.SHOW)
    private Conf<String> dataurl = Holders.simple("");

    public String getApikey() {
        return apikey.get();
    }

    public void setapikey(String url) {
        this.apikey.set(url);
    }

    public String getClientId() {
        return clientId.get();
    }

    public void setClientId(String url) {
        this.clientId.set(url);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public String getTokenurl() {
        return tokenurl.get();
    }

    public void setTokenurl(String url) {
        this.tokenurl.set(url);
    }

    public String getDataurl() {
        return dataurl.get();
    }

    public void setDataurl(String url) {
        this.dataurl.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
