package com.eco.plugin.xxx.bjgjdata.db.dao;

import com.eco.plugin.xxx.bjgjdata.db.bean.OrgEntity;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;
import com.fr.stable.db.session.DAOSession;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.List;

/**
 * @author xxx
 * @version 10.0
 * Created by xxx on 2021-12-03
 **/
public class OrgDao extends BaseDAO<OrgEntity> {

    public OrgDao(DAOSession session) {
        super(session);
    }

    @Override
    protected Class<OrgEntity> getEntityClass() {
        return OrgEntity.class;
    }

    public final static DAOProvider DAO = new DAOProvider() {
        @Override
        public Class getEntityClass() {
            return OrgEntity.class;
        }

        @Override
        public Class<? extends BaseDAO> getDAOClass() {
            return OrgDao.class;
        }
    };

    public void add(OrgEntity entity) throws Exception {
        getSession().persist(entity);
    }

    public void remove(String id) throws Exception {
        getSession().remove(QueryFactory.create()
                        .addRestriction(RestrictionFactory.eq("id", id)),
                this.getEntityClass());
    }

    public void update(OrgEntity entity) throws Exception {
        getSession().merge(entity);
    }


    public OrgEntity getByUsername(String username) throws Exception {
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.eq("username", username));

        return findOne(condition);
    }

    public OrgEntity getByRybh(String rybh) throws Exception {
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.eq("jgid", rybh));

        return findOne(condition);
    }

    public List<OrgEntity> like(String pid, String type)throws Exception{
        QueryCondition condition = QueryFactory.create()
                .addRestriction(RestrictionFactory.like("", pid)).addRestriction(RestrictionFactory.like(OrgEntity.COLUMN_ID,type));
        return find(condition);
    }
}
